double convexDiameter(P[] ps) {
    int n = ps.length;
    int is = 0, js = 0;
    for (int i = 1; i < n; i++) {
        if (ps[i].x > ps[is].x) is = i;
        if (ps[i].x < ps[js].x) js = i;
    }
    double maxd = ps[is].sub(ps[js]).abs();
    int i = is, j = js;
    do {
        if (ps[(i + 1) % n].sub(ps[i]).det(ps[(j + 1) % n].sub(ps[j])) >= 0) {
            j = (j + 1) % n;
        } else {
            i = (i + 1) % n;
        }
        maxd = max(maxd, ps[i].sub(ps[j]).abs());
    } while (i != is || j != js);
    return maxd;
}
