public static int levenshtein_distance(String a, String b) {
    int[] costs = new int[b.length() + 1];
    for (int j = 0; j < costs.length; j++)
        costs[j] = j;
    for (int i = 1; i <= a.length(); i++) {
        costs[0] = i;
        int nw = i - 1;
        for (int j = 1; j <= b.length(); j++) {
            int x = 1 + costs[j];
            int y = 1 + costs[j - 1];
            int z = a.charAt(i - 1) == b.charAt(j - 1) ? nw : nw + 1;
            nw = costs[j];
            costs[j] = Math.min(x, Math.min(y, z));
        }
    }
    return costs[b.length()];
}
