public class SegTree {
    static int[] t;
    static int n, q;
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        n = sc.nextInt(); q = sc.nextInt();
        t = new int[2 * n];
        for (int i = 0; i < n; i++) { t[n + i] = sc.nextInt(); }
        build();
        for (int i = 0; i < q; i++) {
            System.out.println(query(sc.nextInt(), sc.nextInt()));
        }
    }
    static void build() {
        for (int i = n - 1; i >= 0; i--) t[i] = t[i<<1] + t[i<<1|1];
    }
    static void modify(int p, int value) {
        for (t[p += n] = value; p > 1; p >>= 1) t[p>>1] = t[p] + t[p^1];
    }
    static int query(int l, int r) { // sum on interval [l, r)
        int res = 0;
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if ((l&1) > 0) res += t[l++];
            if ((r&1) > 0) res += t[--r];
        }
        return res;
    }
}
