int n = sc.nextInt(); // nr vertices
int m = sc.nextInt(); // nr edges
Edge[] edges = new Edge[m]; // Edge(source, destination, weight)
for (int i = 0; i < m; i++) {
    edges[i] = new Edge(sc.nextInt(), sc.nextInt(), sc.nextInt());
}

int[] d = new int[n];
Arrays.fill(d, Integer.MAX_VALUE); d[0] = 0;
for (int i = 0; i < n - 1; i++) {
    for (int j = 0; j < m; j++) {
        Edge e = edges[j];
        if (d[e.d] > d[e.s] + e.w)
            d[e.d] = d[e.s] + e.w;
    }
}
boolean flag = false;
for (int j = 0; j < m; j++) {
    Edge e = edges[j];
    if (d[e.d] > d[e.s] + e.w) {
        System.out.println("graph has a negative cycle.");
        flag = true;
    }
}
for (int i = 0; !flag && i < n; i++)
System.out.printf("%d --> %d : %d\n", 0, i, d[i]);
System.out.println();
