public class Circle{
    long x,y,r;
    public Circle(long x, long y, long r){
        this.x = x;
        this.y = y;
        this.r = r;
    }
    public Line2D.Double tangent1(long xp, long yp){
        xp -= x; yp -= y;
        Line2D.Double line = new Line2D.Double();
        double a = (xp*xp)+(yp*yp);
        double b = -2*r*r*xp;
        double c = r*r*r*r-yp*yp*r*r;
        double d = b*b-4*a*c;
        double x1 = (-b+Math.sqrt(d))/(2*a);
        double y1 = Math.sqrt(r*r-x1*x1);
        line.setLine(xp+x,yp+y,x1+x,y1+y);
        return line;
    }
    public Line2D.Double tangent2(long xp, long yp){
        xp-=x; yp-=y;
        Line2D.Double line = new Line2D.Double();
        double a = (xp*xp)+(yp*yp);
        double b = -2*r*r*xp;
        double c = r*r*r*r-yp*yp*r*r;
        double d = b*b-4*a*c;
        double x1 = (-b-Math.sqrt(d))/(2*a);
        double y1 = Math.sqrt(r*r-x1*x1);
        line.setLine(xp+x,yp+y,x1+x,y1+y);
        return line;
    }
}
