// S[] the coins available
// m   the number of coins
// n   the total amount
public static long count(int S[], int m, int n) {
    long[][] table = new long[n + 1][m];
    for (int i = 0; i < m; i++) {
        table[0][i] = 1;
    }
    for (int i = 1; i < n + 1; i++) {
        for (int j = 0; j < m; j++) {
            long x = (i - S[j] >= 0) ? table[i - S[j]][j] : 0;
            long y = (j >= 1) ? table[i][j - 1] : 0;
            table[i][j] = x + y;
        }
    }
    return table[n][m - 1];
}
