# Find maximum of unimodal function f() within [left, right]
# For the minimum, revert the if/else statement or revert the comparison.
def ternarySearch(f, left, right, absolutePrecision):
    while True:
    # left and right are the current bounds; the maximum is between them
        if abs(right - left) < absolutePrecision:
            return (left + right)/2
        leftThird = left + (right - left)/3
        rightThird = right - (right - left)/3
        if f(leftThird) < f(rightThird):
            left = leftThird
        else:
            right = rightThird
